/************************************************************************/
/*  Copyright (C), 2016-2020, [IT], Ȩ;
/*  ģ  ;
/*      ǰĿݿʵ;
/*
/*      [V];	
/*      ߣ[IT];
/*      ڣ[11/13/2016];
/*
/*
/*  ע    ⣺;
/*
/*  ޸ļ¼[IT];
/*  ޸ڣ;
/*  ޸İ汾;
/*  ޸ݣ;
/************************************************************************/
#ifndef __DATA_IMPL__
#define __DATA_IMPL__

#pragma once

#include <vector>
#include "TableInfo.h"

class CDataImpl
{
	CDataImpl(void);
public:
	static CDataImpl* GetInstance()
	{
		static CDataImpl *pObj = NULL;
		if ( pObj == NULL )
		{
			pObj = new CDataImpl;
			pObj->Open();
		}

		return pObj;
	}

	virtual ~CDataImpl(void);

	// ˽б;
private:
	sqlite3		*m_psqlite3;
	CHAR		*m_pszErrmsg;

	// û;
public:
	BOOL Open();
	void Close();

	// begin;
	BOOL TransactionBegin()
	{
		INT nRet = sqlite3_exec(m_psqlite3, "begin", 0, 0, &m_pszErrmsg);
		return ( nRet == 0 ) ? TRUE : FALSE;
	}

	BOOL TransactionCommit()
	{
		INT nRet = sqlite3_exec(m_psqlite3, "commit", 0, 0, &m_pszErrmsg);
		return ( nRet == 0 ) ? TRUE : FALSE;
	}

	// commit;
	// ִ;
	BOOL ExecteSQL(IN LPCSTR lpSQL);

	// ѯϵ˷;
	INT QueryContactsType(IN OUT std::vector<STContactsType> &vtContactsType);
	// ѯϵ˱;
	INT QueryContactsInfo(IN OUT std::vector<STContactsInfo> &vtContactsInfo);
	// ѯ;
	INT QueryTaskInfo(IN OUT std::vector<STTaskInfo> &vtTaskInfo);
	// ѯͼ¼;
	INT QuerySendRecord(IN OUT std::vector<STSendRecord> &vtSendRecord);
	// ѯָSendIdĶż¼;
	INT QuerySendRecord(IN LPCSTR lpSendId, IN OUT STSendRecord &SendRecord);
	// ѯָAutoIdĶż¼;
	INT QuerySendRecordByAutoid(IN LPCSTR lpAutoId, IN OUT STSendRecord &SendRecord);

	// ϵ˷;
	BOOL InsertContactsType(IN LPCSTR lpContactsType);
	// ˱;
	BOOL InsertContactsInfo(IN LPCSTR lpContactsType, IN LPCSTR lpContactsName, IN LPCSTR lpContactsPhone, IN LPCSTR lpContactsStatus);
	// ;
	BOOL InsertTaskInfo(IN LPCSTR lpTirrgerCycle, IN LPCSTR lpTirrgerTime, IN LPCSTR lpTaskPhone, IN LPCSTR lpTaskContent, IN LPCSTR lpExecDate, IN LPCSTR lpTaskStatus);
	// 뷢ͼ¼;
	BOOL InsertSendRecord(IN LPCSTR lpSendType,IN LPCSTR lpSendId,IN LPCSTR lpSendDateTime, IN LPCSTR lpSendPhone, IN LPCSTR lpSendContent, IN LPCSTR lpSendStatus, IN LPCSTR lpSendLog);

	// ϵ˷;
	BOOL UpdateContactsType(IN LPCSTR lpAutoid, IN LPCSTR lpContactsType);
	// ϵ˱;
	BOOL UpdateContactsInfo(IN LPCSTR lpAutoid, IN LPCSTR lpContactsType, IN LPCSTR lpContactsName, IN LPCSTR lpContactsPhone, IN LPCSTR lpContactsStatus);
	// ִ״̬-ֻ++ʱ;
	BOOL UpdateTaskInfo(IN LPCSTR lpTirrgerCycle,IN LPCSTR lpTirrgerTime, IN LPCSTR lpTaskPhone, IN LPCSTR lpTaskContent, IN LPCSTR lpExecDate);
	// -Autoid;
	BOOL UpdateTaskInfo(IN LPCSTR lpAutoid, IN LPCSTR lpTirrgerCycle, IN LPCSTR lpTirrgerTime, IN LPCSTR lpTaskPhone, IN LPCSTR lpTaskContent, IN LPCSTR lpExecDate, IN LPCSTR lpTaskStatus);
	// ·ͼ¼;
	BOOL UpdateSendRecord(IN LPCSTR lpSendId, IN LPCSTR lpSendStatus, IN LPCSTR lpSendLog);
	BOOL UpdateSendRecord(IN LPCSTR lpAutoid, IN LPCSTR lpSendId, IN LPCSTR lpSendDateTime, IN LPCSTR lpSendPhone, IN LPCSTR lpSendContent, IN LPCSTR lpSendStatus, IN LPCSTR lpSendLog);

	// ״̬;
	BOOL ClearnTaskStatus(IN LPCSTR lpAutoid);
};

#endif